// Test16P16RDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test16P16R.h"
#include "Test16P16RDlg.h"
#include "DecLib.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest16P16RDlg dialog

CTest16P16RDlg::CTest16P16RDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest16P16RDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest16P16RDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest16P16RDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest16P16RDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest16P16RDlg, CDialog)
	//{{AFX_MSG_MAP(CTest16P16RDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK8,OnBitToggledLowByte)
	ON_COMMAND_RANGE(IDC_CHECK9,IDC_CHECK16,OnBitToggledHighByte)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest16P16RDlg message handlers

BOOL CTest16P16RDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here	
	//if(!GetDevicePortAddress(DECISION_PCI_16P16R_CARD,&m_usPortAddress))
	if(!GetDevicePortAddressEx(&m_usPortAddress))
	{
		AfxMessageBox("Get card address error!");
		EndDialog(-1);
	}
	OpenDecPort();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTest16P16RDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest16P16RDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest16P16RDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTest16P16RDlg::OnBitToggledLowByte(UINT idButton)
	//
	// This function is called, whenever the user has clicked on one
	// of the output line buttons
	//
{
	
		// ------------------------------------------------------------------
		//                        Decision Library Calls:
		//
		// Our Task here:
		// Set the new state of the ports.
		//
		// ------------------------------------------------------------------

	BOOL bState = IsDlgButtonChecked (idButton);
	DWORD dwBit = idButton - IDC_CHECK1;
	UCHAR utemp=0,uctemp = 0,ubit;

	// reset all buttons
	for(DWORD q = 0; q < 8 ; q++)
	{
		if(q != dwBit)
			CheckDlgButton (IDC_CHECK1+q,FALSE);
	}

	// calculate the output value
	if(bState)
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
	}
	else
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
		uctemp = ~uctemp;
	}

	// Now take into account any output bank configured:
	if (!outportb (	m_usPortAddress, uctemp))
	{
		//
		// If unsuccessfull, restore the state of the output button:
		//
		CheckDlgButton (idButton,FALSE);
	}

	// delay to get response, just for demo test
	for(int k= 0; k < 3000; k++)
	{
		for(int j= 0; j < 3000; j++)
		{
		}
	}

	//
	// input the value that we just output
	//	and show the results
	utemp = inportb(m_usPortAddress);

	// Because our loop back test is ==> 
	// Output value : 00000001b = 0x01
	// Input value  : 11111110b = 0xfe
	// So get the complement of input value, and show the reslut
	utemp = ~utemp;

	for(int i = 0; i < 8; i++)
	{
		ubit = utemp >> i;
		ubit = ubit & 0x01;
		if( ubit )
			CheckDlgButton(IDC_CHECK17+i, BST_CHECKED);   // 1
		else
			CheckDlgButton(IDC_CHECK17+i, BST_UNCHECKED);   // 0
	}
}

void CTest16P16RDlg::OnBitToggledHighByte(UINT idButton)
	//
	// This function is called, whenever the user has clicked on one
	// of the output line buttons
	//
{
	
		// ------------------------------------------------------------------
		//                        Decision Library Calls:
		//
		// Our Task here:
		// Set the new state of the ports.
		//
		// ------------------------------------------------------------------

	BOOL bState = IsDlgButtonChecked (idButton);
	DWORD dwBit = idButton - IDC_CHECK9;
	UCHAR utemp=0,uctemp = 0,ubit;

	// reset all buttons
	for(DWORD q = 0; q < 8 ; q++)
	{
		if(q != dwBit)
			CheckDlgButton (IDC_CHECK9+q,FALSE);
	}

	// calculate the output value
	if(bState)
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
	}
	else
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
		uctemp = ~uctemp;
	}

	// Now take into account any output bank configured:
	if (!outportb (	m_usPortAddress+1, uctemp))
	{
		//
		// If unsuccessfull, restore the state of the output button:
		//
		CheckDlgButton (idButton,FALSE);
	}

	// delay to get response, just for demo test
	for(int k= 0; k < 3000; k++)
	{
		for(int j= 0; j < 3000; j++)
		{
		}
	}

	//
	// input the value that we just output
	//	and show the results
	utemp = inportb(m_usPortAddress+1);

	// Because our loop back test is ==> 
	// Output value : 00000001b = 0x01
	// Input value  : 11111110b = 0xfe
	// So get the complement of input value, and show the reslut
	utemp = ~utemp;
	for(int i = 0; i < 8; i++)
	{
		ubit = utemp >> i;
		ubit = ubit & 0x01;
		if( ubit )
			CheckDlgButton(IDC_CHECK25+i, BST_CHECKED);   // 1
		else
			CheckDlgButton(IDC_CHECK25+i, BST_UNCHECKED);   // 0
	}
}

